public class Math1 {
    public static int fakultaet(int n) {
        if (!(n >= 0))
            throw new IllegalArgumentException("n muss nicht-negativ sein");
        if (n == 0)
            return 1;
        else
            return n * fakultaet(n-1);
    }
    public static void main(String[] args) {
        try {
            System.out.println("fakultaet(3) = "+fakultaet(3));
            System.out.println("fakultaet(-1) = "+fakultaet(-1));
	    /*
	     * Folgende Anweisung wird nie ausgefhrt, da
	     * eine Exception zum Verlassen des try-Blocks fhrt.
	     */
	    System.out.println("...");
        }
	/*
	 * Anordnung der catch-Blcke vom Untertyp zum Obertyp
	 * (speziell zuerst, allgemeiner danach)
	 */
	catch (IllegalArgumentException e) {
	    System.out.println("IllegalArgumentException: "+e);
	}
	catch (Exception e) {
	    System.out.println("Exception: "+e);
	}
	finally {
	    /*
	     * die Anweisungen in finally werden IMMER
	     * ausgefhrt - egal ob's eine Exception gab oder nicht!
	     */
	    System.out.println("Diese Ausgabe wird immer gemacht!");
	}
    }
}
